Imports System.Xml

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents txtResults As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtResults = New System.Windows.Forms.TextBox
        Me.SuspendLayout()
        '
        'txtResults
        '
        Me.txtResults.Dock = System.Windows.Forms.DockStyle.Fill
        Me.txtResults.Location = New System.Drawing.Point(0, 0)
        Me.txtResults.Multiline = True
        Me.txtResults.Name = "txtResults"
        Me.txtResults.ReadOnly = True
        Me.txtResults.Size = New System.Drawing.Size(232, 205)
        Me.txtResults.TabIndex = 0
        Me.txtResults.Text = ""
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(232, 205)
        Me.Controls.Add(Me.txtResults)
        Me.Name = "Form1"
        Me.Text = "UseXmlTextReader"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Const FILE_NAME As String = "C:\Employees.xml"
        Dim quantity As Integer
        Dim xml_text_reader As New XmlTextReader(FILE_NAME)
        Dim last_name As String
        Dim first_name As String
        Dim phone As String
        Dim txt As String

        ' Skip all whitespace.
        xml_text_reader.WhitespaceHandling = WhitespaceHandling.None

        ' Move to the Employees data root node.
        xml_text_reader.MoveToContent()

        ' Read the first element inside the root.
        xml_text_reader.Read()

        ' Read until we reach the end of the file.
        Do While Not xml_text_reader.EOF
            ' See if this is an Employee start tag.
            If xml_text_reader.Name <> "Employee" Or _
               xml_text_reader.NodeType <> XmlNodeType.Element _
            Then
                ' Not an Employee. 
                ' Skip it and its children.
                xml_text_reader.Skip()
            Else
                ' An Employee. Process it.
                last_name = ""
                first_name = ""
                phone = ""

                ' Get the first child element.
                xml_text_reader.Read()
                Do
                    ' See what it is.
                    Select Case xml_text_reader.Name
                        Case "LastName"
                            last_name = xml_text_reader.ReadElementString()
                        Case "FirstName"
                            first_name = xml_text_reader.ReadElementString()
                        Case "Phone"
                            ' See if Type = Work.
                            If xml_text_reader.GetAttribute("Type") = "Work" Then
                                ' Work. Save it.
                                phone = xml_text_reader.ReadElementString()
                            Else
                                ' Not Work. Skip it.
                                xml_text_reader.Skip()
                            End If
                        Case "Employee"
                            ' It's the Employee end tag.
                            ' Skip it and look for
                            ' the next Employee.
                            xml_text_reader.Skip()
                            Exit Do
                        Case Else
                            ' Skip this node.
                            xml_text_reader.Skip()
                    End Select
                Loop

                ' Add the Employee's data to the result.
                txt &= first_name & " " & _
                    last_name & _
                    " (" & phone & ")" & vbCrLf
            End If
        Loop
        ' Close the file.
        xml_text_reader.Close()

        ' Display the results.
        txtResults.Text = txt
        txtResults.Select(0, 0)
    End Sub
End Class
