Option Explicit On 
Option Strict On

Imports System.IO
Imports System.Xml.Serialization
Imports System.Math

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Private components As System.ComponentModel.IContainer
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileSaveAs As System.Windows.Forms.MenuItem
    Friend WithEvents picCanvas As System.Windows.Forms.PictureBox
    Friend WithEvents mnuFileExit As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuPictureClear As System.Windows.Forms.MenuItem
    Friend WithEvents dlgSave As System.Windows.Forms.SaveFileDialog
    Friend WithEvents dlgOpen As System.Windows.Forms.OpenFileDialog
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem
        Me.mnuFileSaveAs = New System.Windows.Forms.MenuItem
        Me.mnuFileExit = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.mnuPictureClear = New System.Windows.Forms.MenuItem
        Me.picCanvas = New System.Windows.Forms.PictureBox
        Me.dlgSave = New System.Windows.Forms.SaveFileDialog
        Me.dlgOpen = New System.Windows.Forms.OpenFileDialog
        Me.SuspendLayout()
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1, Me.MenuItem2})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileOpen, Me.mnuFileSaveAs, Me.mnuFileExit})
        Me.MenuItem1.Text = "&File"
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 0
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open..."
        '
        'mnuFileSaveAs
        '
        Me.mnuFileSaveAs.Index = 1
        Me.mnuFileSaveAs.Shortcut = System.Windows.Forms.Shortcut.CtrlA
        Me.mnuFileSaveAs.Text = "Save &As..."
        '
        'mnuFileExit
        '
        Me.mnuFileExit.Index = 2
        Me.mnuFileExit.Text = "E&xit"
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 1
        Me.MenuItem2.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuPictureClear})
        Me.MenuItem2.Text = "&Picture"
        '
        'mnuPictureClear
        '
        Me.mnuPictureClear.Index = 0
        Me.mnuPictureClear.Text = "&Clear"
        '
        'picCanvas
        '
        Me.picCanvas.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.picCanvas.Dock = System.Windows.Forms.DockStyle.Fill
        Me.picCanvas.Location = New System.Drawing.Point(0, 0)
        Me.picCanvas.Name = "picCanvas"
        Me.picCanvas.Size = New System.Drawing.Size(360, 301)
        Me.picCanvas.TabIndex = 1
        Me.picCanvas.TabStop = False
        '
        'dlgSave
        '
        Me.dlgSave.DefaultExt = "lines"
        Me.dlgSave.Filter = "Line Files|*.lines|All Files|*.*"
        Me.dlgSave.Title = "Save File"
        '
        'dlgOpen
        '
        Me.dlgOpen.DefaultExt = "lines"
        Me.dlgOpen.Filter = "Line Files|*.lines|All Files|*.*"
        Me.dlgOpen.Title = "Open File"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(360, 301)
        Me.Controls.Add(Me.picCanvas)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "DrawLines"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' The current picture.
    Private m_CanvasBitmap As Bitmap

    ' The current picture object.
    Private m_edPicture As New edPicture

    ' The new line.
    Private m_NewLine As edLine

    ' Initialize the canvas Bitmap.
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Set the dialogs' initial directories.
        Dim init_dir As String = Application.StartupPath
        init_dir = init_dir.Substring(0, init_dir.LastIndexOf("\"))
        dlgSave.InitialDirectory = init_dir
        dlgOpen.InitialDirectory = init_dir

        ' Make the new Bitmap.
        m_CanvasBitmap = New Bitmap( _
            picCanvas.ClientSize.Width, _
            picCanvas.ClientSize.Height)
        m_edPicture.PictureWidth = m_CanvasBitmap.Width
        m_edPicture.PictureHeight = m_CanvasBitmap.Height

        ' Clear the Bitmap.
        Dim gr As Graphics = Graphics.FromImage(m_CanvasBitmap)
        gr.Clear(picCanvas.BackColor)
        gr.Dispose()

        ' Display the Bitmap.
        picCanvas.Image = DirectCast(m_CanvasBitmap.Clone(), Bitmap)
    End Sub

    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub
    Private Sub mnuPictureClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuPictureClear.Click
        ' Clear the picture.
        Dim gr As Graphics = Graphics.FromImage(m_CanvasBitmap)
        gr.Clear(picCanvas.BackColor)

        ' Display the result.
        picCanvas.Image = DirectCast(m_CanvasBitmap.Clone(), Bitmap)

        ' Create a new edPicture object.
        m_edPicture = New edPicture
        m_edPicture.PictureWidth = m_CanvasBitmap.Width
        m_edPicture.PictureHeight = m_CanvasBitmap.Height
    End Sub
    Private Sub mnuFileSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSaveAs.Click
        If dlgSave.ShowDialog() = DialogResult.OK Then
            SavePicture(dlgSave.FileName)
            dlgOpen.InitialDirectory = dlgSave.InitialDirectory
        End If
    End Sub
    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        If dlgOpen.ShowDialog() = DialogResult.OK Then
            LoadPicture(dlgOpen.FileName)
            dlgSave.InitialDirectory = dlgOpen.InitialDirectory
        End If
    End Sub

    ' Resize the canvas bitmap.
    Private Sub picCanvas_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles picCanvas.Resize
        ' If m_CanvasBitmap Is Nothing, do nothing.
        ' Form_Load will handle it the first time.
        If m_CanvasBitmap Is Nothing Then Exit Sub

        ' Make the Bitmap big enough for picCanvas.
        ' See how big we need to make it.
        Dim new_wid As Integer = Max( _
            picCanvas.ClientSize.Width, m_CanvasBitmap.Width)
        Dim new_hgt As Integer = Max( _
            picCanvas.ClientSize.Height, m_CanvasBitmap.Height)

        ' Do nothing if it's already big enough.
        If new_wid <= m_CanvasBitmap.Width And _
           new_hgt <= m_CanvasBitmap.Height _
                Then Exit Sub

        ' Make the new bitmap.
        Dim new_bm As New Bitmap(new_wid, new_hgt)
        Dim gr As Graphics = Graphics.FromImage(new_bm)
        gr.Clear(picCanvas.BackColor)

        ' Copy the existing image onto the new one.
        gr.DrawImage(m_CanvasBitmap, New Point(0, 0))
        gr.Dispose()

        ' Save the new bitmap.
        m_CanvasBitmap.Dispose()
        m_CanvasBitmap = new_bm

        ' Record the new size.
        m_edPicture.PictureWidth = m_CanvasBitmap.Width
        m_edPicture.PictureHeight = m_CanvasBitmap.Height
    End Sub

    ' Save the picture's serialization.
    Private Sub SavePicture(ByVal file_name As String)
        ' Open the output file.
        Dim file_stream As New FileStream(file_name, FileMode.Create)

        ' Make a serializer.
        Dim xml_serializer As New XmlSerializer(GetType(edPicture))

        ' Serialize the picture into the file.
        xml_serializer.Serialize(file_stream, m_edPicture)

        ' Close the file.
        file_stream.Close()
    End Sub

    ' Load a picture from the file.
    Private Sub LoadPicture(ByVal file_name As String)
        ' Open the input file.
        Dim file_stream As New FileStream(file_name, FileMode.Open)

        ' Make a serializer.
        Dim xml_serializer As New XmlSerializer(GetType(edPicture))

        ' Deserialize the picture from the file
        ' into a new edPicture object.
        Dim new_picture As edPicture
        Try
            new_picture = DirectCast( _
                xml_serializer.Deserialize(file_stream), _
                edPicture)
        Catch ex As Exception
            MsgBox(ex.Message)
            Exit Sub
        End Try
        m_edPicture = new_picture
        m_edPicture.NumLines = m_edPicture.Lines.GetUpperBound(0) + 1

        ' Close the file.
        file_stream.Close()

        ' Make the Bitmap big enough.
        m_CanvasBitmap = New Bitmap(m_edPicture.PictureWidth, m_edPicture.PictureHeight)

        ' Draw on the Bitmap.
        Dim gr As Graphics = Graphics.FromImage(m_CanvasBitmap)
        gr.Clear(picCanvas.BackColor)
        For i As Integer = 0 To m_edPicture.NumLines - 1
            m_edPicture.Lines(i).Draw(gr)
        Next i

        ' Display the new picture.
        Dim bm As Bitmap = DirectCast(m_CanvasBitmap.Clone(), Bitmap)
        picCanvas.Image = bm
    End Sub

    Private Sub picCanvas_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picCanvas.MouseDown
        m_NewLine = New edLine

        ' Start the new object.
        m_NewLine.Start(e.X, e.Y)

        ' Add the object to the edPicture.
        With m_edPicture
            ReDim Preserve .Lines(.NumLines)
            .Lines(.NumLines) = m_NewLine
            .NumLines += 1
        End With
    End Sub
    Private Sub picCanvas_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picCanvas.MouseMove
        ' Do nothing if we're not drawing.
        If m_NewLine Is Nothing Then Exit Sub

        ' Update the new object.
        m_NewLine.Continue(e.X, e.Y)

        ' Display the picture with the updated object.
        Dim bm As Bitmap = DirectCast(m_CanvasBitmap.Clone(), Bitmap)
        Dim gr As Graphics = Graphics.FromImage(bm)
        m_NewLine.Draw(gr, True)
        gr.Dispose()
        picCanvas.Image = bm
    End Sub
    Private Sub picCanvas_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picCanvas.MouseUp
        ' Do nothing if we're not drawing.
        If m_NewLine Is Nothing Then Exit Sub

        ' Update the new object.
        m_NewLine.Finish(e.X, e.Y)

        ' Draw the new object permanently on the picture.
        Dim gr As Graphics = Graphics.FromImage(m_CanvasBitmap)
        m_NewLine.Draw(gr)
        gr.Dispose()

        ' Display the picture with the updated object.
        picCanvas.Image = DirectCast(m_CanvasBitmap.Clone(), Bitmap)

        ' We're done drawing this object.
        m_NewLine = Nothing
    End Sub
End Class
