Imports System.Math

Public Class edStar
    Inherits edDrawable

    Public Overrides Sub Draw(ByVal gr As System.Drawing.Graphics, Optional ByVal temporary As Boolean = False)
        ' Get an appropriate pen.
        Dim star_pen As Pen
        If temporary Then
            star_pen = New Pen(Color.Red)
            star_pen.DashStyle = Drawing2D.DashStyle.Custom
            star_pen.DashPattern = New Single() {8, 8}
        Else
            star_pen = Pens.Black
        End If

        ' Define the star's points.
        Dim pts(9) As Point
        Dim cx As Single = (X1 + X2) / 2
        Dim cy As Single = (Y1 + Y2) / 2
        Dim rx As Single = (X1 - X2) / 2
        Dim ry As Single = (Y1 - Y2) / 2
        Const PI = 3.14159265
        Dim theta As Single = PI / 2
        Dim dtheta As Single = PI / 5
        For i As Integer = 0 To 9 Step 2
            With pts(i)
                .X = cx + rx * Cos(theta)
                .Y = cy + ry * Sin(theta)
            End With
            theta += dtheta

            With pts(i + 1)
                .X = cx + rx * 0.4 * Cos(theta)
                .Y = cy + ry * 0.4 * Sin(theta)
            End With
            theta += dtheta
        Next i

        ' Draw the star.
        gr.DrawPolygon(star_pen, pts)
    End Sub
End Class
